/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 */
package strawberry.tools;

import com.sun.facelets.FaceletHandler;
import com.sun.facelets.tag.Tag;
import com.sun.facelets.tag.TagConfig;

/**
 * Passed to the constructor of TagHandler, it defines the document definition
 * of the handler we are instantiating
 * 
 * @see com.sun.facelets.tag.TagHandler
 * @author Jacob Hookom
 * @version $Id: TagConfig.java,v 1.2 2005/08/24 04:38:48 jhook Exp $
 */
public class TagConfigImpl implements TagConfig {

  Tag tag = null;
  public TagConfigImpl() {
  }
  public TagConfigImpl(Tag tag) {
    this.tag = tag;
  }
    /**
     * A Tag representing this handler
     * 
     * @return a tag representing this handler
     */
  public Tag getTag() {
    return tag;
  }

    /**
     * The next FaceletHandler (child or children) to be applied
     * 
     * @return next FaceletHandler, never null
     */
  public FaceletHandler getNextHandler() {
    return null;
  }

    /**
     * A document-unique id, follows the convention "_tagId##"
     * 
     * @return a document-unique id
     */
  public String getTagId() {
    return null;
  }
}
